# ============================================================
# AutoIDGenerator.py
# provides methods for building auto IDs.
# ------------------------------------------------------------
# Copyright (C) 2004-2005 the Kumula Team.
# Licensed under the LGPL.
# ============================================================

#import kumula
from qt import QDate,QString,QChar
from random import randint

# ------------------------------------------------------------


numberChars  = "0123456789"
alphaChars   = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"


def _YEAR(aLen):
    myYear = QString("%i" % QDate.currentDate().year())
    myYear = myYear.rightJustify(aLen, QChar("0"))
    myYear = myYear.right(aLen)
    return myYear

def _MONTH(aLen):
    myMonth = QString("%i" % QDate.currentDate().month())
    myMonth = myMonth.rightJustify(aLen, QChar("0"))
    myMonth = myMonth.right(aLen)
    return myMonth

def _DAY(aLen):
    myDay = QString("%i" % QDate.currentDate().day())
    myDay = myDay.rightJustify(aLen, QChar("0"))
    myDay = myDay.right(aLen)
    return myDay

def randomInternal(aLen, aTemplate):
    myStr = QString("")
    while (myStr.length() < aLen):
        myStr.append(aTemplate[randint(0, len(aTemplate)-1)])
    return myStr

def _RANDOM(aLen):
    myStr = QString("")
    while (myStr.length() < aLen):
        if randint(0, 1) > 0:
            myStr.append(randomInternal(1, alphaChars))
        else:
            myStr.append(randomInternal(1, numberChars))
    return myStr

def _RANDOMNUMBER(aLen):
    return randomInternal(aLen, numberChars)

def _RANDOMALPHA(aLen):
    return randomInternal(aLen, alphaChars)

def _NAME(aLen, aTitle):
    myStr = QString(aTitle)
    myStr = myStr.left(aLen)
    return myStr

def _UNAME(aLen, aTitle):
    myStr = _NAME(aLen, aTitle)
    myStr = myStr.upper()
    return myStr

def _NAMEINDEX(aLen, aTitle):
    myStr = _UNAME(1, aTitle)
    myIndex = QString(alphaChars).find(myStr)
    myIndex = myIndex+1
    myStr = QString("%i" % myIndex)
    myStr = myStr.rightJustify(aLen, QChar("0"))
    return myStr




def autoID(aTemplate, aTitle, aTable=None, anIDfield=None):
    myStr = QString(aTemplate)
    myStr = myStr.replace("YEAR", _YEAR(4))
    myStr = myStr.replace("MONTH", _MONTH(2))
    myStr = myStr.replace("DAY", _DAY(2))
    myStr = myStr.replace("RANDOMALPHA", _RANDOMALPHA(5))
    myStr = myStr.replace("RANDOMNUMBER", _RANDOMNUMBER(5))
    myStr = myStr.replace("RANDOM", _RANDOM(6))
    myStr = myStr.replace("UNAME", _UNAME(2,aTitle))
    myStr = myStr.replace("NAMEINDEX", _NAMEINDEX(2,aTitle))
    myStr = myStr.replace("NAME", _NAME(2,aTitle))
    return myStr



# Einige Demos:
# autoID("YEAR/MONTH/RANDOMNUMBER", "")        =  2006/04/02480
# autoID("RANDOMNUMBERUNAMEYEAR", "Gerner")    =  06835GE2006
# autoID("2NAMEINDEXRANDOMNUMBER", "Juergen")  =  21092623

