
import os
from qt import *


class KIconSelectDialog(QDialog):

    def __init__(self, parent, directory):
        QDialog.__init__(self, parent, "IconSelectDialog", 0, 0)
        self.setCaption("Please select an icon")
        self.iconDirectory = directory
        IconSelectDialogLayout = QGridLayout(self,1,1,11,6,"IconSelectDialogLayout")

        self.ivIcons = QIconView(self,"ivIcons")
        self.ivIcons.setItemsMovable(0)
#        self.ivIcons.setGridX(4)
#        self.ivIcons.setGridY(2)
        IconSelectDialogLayout.addMultiCellWidget(self.ivIcons,0,0,0,2)

        aSpacer = QSpacerItem(81,21,QSizePolicy.Expanding,QSizePolicy.Minimum)
        IconSelectDialogLayout.addItem(aSpacer,1,0)

        self.btnOK = QPushButton(self,"btnOK")
        self.btnOK.setText(QString("&OK"))
        self.btnOK.setAccel(QString("Alt+O"))
        IconSelectDialogLayout.addWidget(self.btnOK,1,1)

        self.btnCancel = QPushButton(self,"btnCancel")
        self.btnCancel.setText(QString("&Cancel"))
        self.btnCancel.setAccel(QString("Alt+C"))
        IconSelectDialogLayout.addWidget(self.btnCancel,1,2)

        self.resize(QSize(420,300).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)
        self.connect(self.btnOK,     SIGNAL("clicked()"), self.accept)
        self.connect(self.btnCancel, SIGNAL("clicked()"), self.reject)

        self.loadIcons()



    def loadIcons(self):
        self.ivIcons.clear()
        osDirList = os.listdir(self.iconDirectory)
        osDirList.sort()
        for iconFile in osDirList:
            myPixmap = QPixmap(QString(os.path.join(self.iconDirectory, iconFile)))
            myLabel = QString(iconFile)
            myLabel.replace(".png", "")
            myItem = QIconViewItem(self.ivIcons, myLabel, myPixmap)


    def getIconName(self):
        return self.ivIcons.currentItem().text().ascii()


    def getIconPath(self):
        return os.path.join(self.iconDirectory, self.getIconName() + ".png")


    def selectedPixmap(self):
        return QPixmap(self.getIconPath())

