# ============================================================
# ProgressDialog.py
# global dialog with progress bar.
# ------------------------------------------------------------
# Copyright (C) 2004 the Kumula Team.
# ============================================================

import kumula
from qt import Qt,QDialog,QVBoxLayout,QProgressBar,QLabel,QSize


class KProgressDialog(QDialog):

    def __init__(self, parent, title, comment):

        QDialog.__init__(self,parent,"ProgressDialog", 1, 0)
        ProgressDialogLayout = QVBoxLayout(self,11,6,"ProgressDialogLayout")

        self.lblComment = QLabel(self,"lblComment")
        ProgressDialogLayout.addWidget(self.lblComment)

        self.pbProgress = QProgressBar(self,"pbProgress")
        self.pbProgress.setProgress(0)
        ProgressDialogLayout.addWidget(self.pbProgress)

        self.myTitle   = title
        self.myComment = comment
        self.languageChange()
        self.setTarget(0)

        self.resize(QSize(330,85).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)


    def languageChange(self):
        self.setCaption(self.myTitle)
        self.lblComment.setText(self.myComment)


    def setTarget(self, targetValue):
        self.pbProgress.setTotalSteps(targetValue)
        self.pbProgress.setProgress(0)


    def setPosition(self, value):
        self.pbProgress.setProgress(value)
        kumula.Program.processEvents()


