# ============================================================
# SpecialItems.py
# new List-/Icon-ViewItems classes with a hidden ID ("tag")
# ------------------------------------------------------------
# Copyright (C) 2004 the Kumula Team.
# Licensed under the LGPL.
# ============================================================

from qt import QListViewItem,QIconViewItem,QColor,QColorGroup

# ------------------------------------------------------------


class KListViewItemWithID(QListViewItem):

    def __init__(self, parent, tag=0):
        QListViewItem.__init__(self, parent)
        self.tag = tag


# ------------------------------------------------------------


class KIconViewItemWithID(QIconViewItem):

    def __init__(self, parent, title, icon, tag):
        QIconViewItem.__init__(self, parent, title, icon)
        self.tag = tag


# ------------------------------------------------------------


class KColoredListViewItem(KListViewItemWithID):

    def setColor(self, color):
        self.myColor = color

    def paintCell(self, p, cg, column, width, align):
        myCG = QColorGroup(cg)
        myCG.setColor(QColorGroup.Text, QColor(self.myColor))
        QListViewItem.paintCell(self, p, myCG, column, width, align)

