
# ============================================================
# UserInterface.py
# provides methods for manipulating user data to all apps.
# ------------------------------------------------------------
# Copyright (C) 2005 the Kumula Team.
# Licensed under the LGPL.
# ============================================================

import kumula
from qt import QString

# ------------------------------------------------------------


def getAllUsers():
    myUserList = ()
    quUsers = kumula.DB.doSelect("users", ("username",), "username")
    while quUsers.next():
        myUserName = quUsers.value(0).toString()
        myUser = KUser(myUserName)
        myUserList = myUserList + (myUser,)
    return myUserList


def getUserByID(anID):
    quUsers = kumula.DB.doSelect("users", ("username",), "username", {"id":"%i" % anID})
    found = 0
    while quUsers.next():
        myUserName = quUsers.value(0).toString()
        myUser = KUser(myUserName)
        found = 1
    if (found == 0):
        myUser = KUser(None)
    return myUser



class KUser(object):

    def __init__(self, anUsername):
        self.userName = anUsername
        self.userID   = 0
        self.employID = ""
        self.surename = ""
        self.forename = ""
        if (self.userName):
            quUser = kumula.DB.doSelect("users", ("id","employid","name","forename"), "", {"username":self.userName})
            while quUser.next():
                self.userID   = quUser.value(0).toInt()
                self.employID = quUser.value(1).toString()
                self.surename = quUser.value(2).toString()
                self.forename = quUser.value(3).toString()


    def getFormattedName(self):
        myName = QString(self.surename)
        if (self.surename != "") and (self.forename != ""):
            myName.append(", ")
        myName.append(self.forename)
        if (myName == ""):
            myName.append(self.userName)
        return myName

