# ============================================================
# UserObjects.py
# provides methods for manipulating user data to all apps.
# ------------------------------------------------------------
# Copyright (C) 2006 the Kumula Team.
# Licensed under the LGPL.
# ============================================================

import kumula
from qt import QString

# ------------------------------------------------------------


class KUser(object):

    def __init__(self):
        self.myUserName = ""
        self.myUserID   = 0
        self.myEmployID = ""
        self.mySurename = ""
        self.myForename = ""

    def byID(self, aUserID):
        quUser = kumula.DB.doSelect("users", ("username","employid","name","forename"), "", {"id":"%i" % aUserID})
        while quUser.next():
            self.myUserName = quUser.value(0).toString()
            self.myEmployID = quUser.value(1).toString()
            self.mySurename = quUser.value(2).toString()
            self.myForename = quUser.value(3).toString()
        return self

    def byUserName(self, aUserName):
        quUser = kumula.DB.doSelect("users", ("id","employid","name","forename"), "", {"username":aUserName})
        while quUser.next():
            self.myUserID   = quUser.value(0).toInt()
            self.myEmployID = quUser.value(1).toString()
            self.mySurename = quUser.value(2).toString()
            self.myForename = quUser.value(3).toString()
        return self

    def id():
        return self.myUserID

    def username():
        return self.myUserName

    def employID():
        return self.myEmployID

    def surename():
        return self.mySurename

    def forename():
        return self.myForename

    def formattedName(self):
        myName = QString(self.surename)
        if (self.surename != "") and (self.forename != ""):
            myName.append(", ")
        myName.append(self.forename)
        if (myName == ""):
            myName.append(self.userName)
        return myName

    def allUsers():
        myUserList = ()
        quUsers = kumula.DB.doSelect("users", ("id",), "id")
        while quUsers.next():
            myUserID = quUsers.value(0).toInt()
            myUser = KUser().byID(myUserID)
            myUserList = myUserList + (myUser,)
        return myUserList


# return the currently logged in User
    def currentUser():
        return self

# return the path to the home directory of this (self) user
    def homeDir():
        return QString

