

import kumula
from qt import *
from SideBar import KSideBar
from KumulaMainWindow import KKumulaMainWindow,KAction

import sys
import os

# ------------------------------------------------------------


class KMainWindow(KKumulaMainWindow):

    def getProgramName(self):
        return "BizCalc"

    def getProgramVersion(self):
        return "1.0"


    def createUI(self):
#        no, we don't need a statusbar!
#        self.statusBar()
#        self.setIcon(kumula.getProgIcon("calculator"))
        KKumulaMainWindow.createUI(self)

        self.setCentralWidget(QWidget(self, "qt_central_widget"))
        myLayout = QHBoxLayout(self.centralWidget())

        self.sideBar = KSideBar(self.centralWidget(), "SideBar")
        myLayout.addWidget(self.sideBar)

        self.widgetFrame = QFrame(self.centralWidget())
        self.widgetFrame.setFrameShape(QFrame.NoFrame)
        widgetFrameLayout = QVBoxLayout(self.widgetFrame, 10, 10)
        myLayout.addWidget(self.widgetFrame)

#        self.titleFrame = QFrame(self.widgetFrame,"titleFrame")
#        self.titleFrame.setSizePolicy(QSizePolicy(QSizePolicy.Preferred,QSizePolicy.Fixed,0,0,self.titleFrame.sizePolicy().hasHeightForWidth()))
#        self.titleFrame.setFrameShape(QFrame.NoFrame)
#        self.titleFrame.setFrameShadow(QFrame.Plain)
#        titleFrameLayout = QGridLayout(self.titleFrame,1,1,11,6,"titleFrameLayout")

#        self.titlePixmap = QLabel(self.titleFrame,"titlePixmap")
#        self.titlePixmap.setScaledContents(0)
#        titleFrameLayout.addMultiCellWidget(self.titlePixmap,0,1,0,0)

#        self.titleLabel = QLabel(self.titleFrame,"titleLabel")
#        titleLabel_font = QFont(self.titleLabel.font())
#        titleLabel_font.setPointSize(16)
#        titleLabel_font.setBold(1)
#        self.titleLabel.setFont(titleLabel_font)
#        titleFrameLayout.addWidget(self.titleLabel,0,1)
#        self.titleDesc = QLabel(self.titleFrame,"titleDesc")
#        titleFrameLayout.addWidget(self.titleDesc,1,1)

#        titleSpacer = QSpacerItem(220,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
#        titleFrameLayout.addMultiCell(titleSpacer,0,1,2,2)

#        widgetFrameLayout.addWidget(self.titleFrame)

        self.widgetStack = QWidgetStack(self.widgetFrame)
#        self.widgetStack.setFrameShape(QFrame.StyledPanel)
        self.widgetStack.setFrameShape(QFrame.NoFrame)
        self.widgetStack.setFrameShadow(QFrame.Raised)
        self.loadWidgets()
        widgetFrameLayout.addWidget(self.widgetStack)

        self.resize(QSize(0,0).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)





    def createMenuBar(self):
        KKumulaMainWindow.createMenuBar(self)

        # initialize Actions
        self.actCalcNew  = KAction(self, "calc_new",  "&New...",  None, "Reset all values and start a new calculation.")
        self.actCalcOpen = KAction(self, "calc_open", "&Open...", None, "Import stored values and continue calculation.")
        self.actCalcSave = KAction(self, "calc_save", "&Save...", None, "Export current values to a file.")

        # create Menu Structure
        self.menuCalc = self.makePopupMenu()
        self.actCalcNew.addToMenuBar(self.menuCalc)
        self.actCalcOpen.addToMenuBar(self.menuCalc)
        self.actCalcSave.addToMenuBar(self.menuCalc)
#        self.MenuBar.insertItem(QString("&Calculation"), self.menuCalc, 0)

        self.menuModule = self.makePopupMenu()
        self.MenuBar.insertItem(QString("&Module"), self.menuModule, 1)


    def createToolBar(self):
        pass



    def updateView(self):
        self.widgetStack.raiseWidget(self.sideBar.currentButton())
        curWidget = self.widgetStack.visibleWidget()
#        self.titleLabel.setText(curWidget.caption())
#        self.titleDesc.setText(curWidget.getDescription())
#        self.titlePixmap.setPixmap(curWidget.icon())



    def loadWidgets(self):
        self.widgetByID = {}
        firstID = -99
        self.widgetTuple = ()

        myViewerDir = os.path.join(os.path.dirname(sys.argv[0]), "..", "lib", "bizcalc")
        # get list of all "widget_" files in KUMULADIR/lib/calculator
        osList = os.listdir(myViewerDir)
        osList.sort()
        for name in osList:
            myFileName = QString(name)
            if (myFileName.left(7) == "widget_"):
                myFile = os.path.join(myViewerDir, name)

                myPlugin = open(myFile, "r")
                # ...compile it...
                exec myPlugin in locals()
                myPlugin.close()
                # ...and add it to our tab bar
                myWidget = CalcWidget(self.widgetStack)
                myID = self.widgetStack.addWidget(myWidget)
                self.widgetTuple = self.widgetTuple + (myWidget,)

                if (firstID == -99):
                    firstID = myID

                myTitle = myWidget.caption()
                self.sideBar.insertButton(myTitle, myWidget.icon(), myID)
                self.widgetByID[myID] = myWidget

                menuID = self.menuModule.insertItem(myTitle, self.handleModuleSelected)
                self.menuModule.setItemParameter(menuID, myID)
#                self.menuModule.setItemEnabled(menuID, 0)

        self.sideBar.insertSpacer()
        self.connect(self.sideBar, PYSIGNAL("selectionChanged()"), self.updateView)
        self.sideBar.selectButton(firstID)


    def handleModuleSelected(self, aWidgetID):
        self.sideBar.selectButton(aWidgetID)


