

from widgetTmpl_calculator import WidgetCalculator
import kumula
from qt import *



class CalcWidget(WidgetCalculator):

    def __init__(self, parent):
        WidgetCalculator.__init__(self, parent)
        self.setIcon(kumula.getSideBarIcon("calculator"))
        self.lvStripe.setColumnAlignment(1, Qt.AlignRight)
        self.connect(self.btnValue0, SIGNAL("clicked()"), self.handleButton0)
        self.connect(self.btnValue1, SIGNAL("clicked()"), self.handleButton1)
        self.connect(self.btnValue2, SIGNAL("clicked()"), self.handleButton2)
        self.connect(self.btnValue3, SIGNAL("clicked()"), self.handleButton3)
        self.connect(self.btnValue4, SIGNAL("clicked()"), self.handleButton4)
        self.connect(self.btnValue5, SIGNAL("clicked()"), self.handleButton5)
        self.connect(self.btnValue6, SIGNAL("clicked()"), self.handleButton6)
        self.connect(self.btnValue7, SIGNAL("clicked()"), self.handleButton7)
        self.connect(self.btnValue8, SIGNAL("clicked()"), self.handleButton8)
        self.connect(self.btnValue9, SIGNAL("clicked()"), self.handleButton9)
        self.connect(self.btnValue00, SIGNAL("clicked()"), self.handleButton00)
        self.connect(self.btnDot, SIGNAL("clicked()"), self.handleButtonDot)
        self.connect(self.btnOpPlus, SIGNAL("clicked()"), self.handleButtonPlus)
        self.connect(self.btnOpMinus, SIGNAL("clicked()"), self.handleButtonMinus)
        self.connect(self.btnOpMultiplicate, SIGNAL("clicked()"), self.handleButtonMultiplicate)
        self.connect(self.btnOpDivide, SIGNAL("clicked()"), self.handleButtonDivide)
        self.connect(self.btnOpPercent, SIGNAL("clicked()"), self.handleButtonPercent)
        self.connect(self.btnOpEnter, SIGNAL("clicked()"), self.handleButtonEnter)
        self.connect(self.btnClear, SIGNAL("clicked()"), self.handleButtonClear)
        self.lvStripe.clear()
        self.lvStripe.setSorting(-1)
        self.handleButtonClear()



    def getDescription(self):
        return "RPN calculator"

    def insertLine(self, anOp, aValue):
        item = QListViewItem(self.lvStripe, self.lvStripe.lastItem())
        item.setText(0, anOp)
        item.setText(1, aValue)
        self.lvStripe.ensureItemVisible(item)


    def handleValue(self, aValue):
        self.DISPLAY.append("%i" % aValue)
        self.lcDisplay.display(self.DISPLAY)


    def handleOperation(self, anOp):
        error = 0
        dispValue = self.DISPLAY.toFloat()[0]
        self.insertLine(anOp, self.DISPLAY)
        if (anOp == "+"):
            self.VALUE = self.VALUE + dispValue
        elif (anOp == "-"):
            self.VALUE = self.VALUE - dispValue
        elif (anOp == "*"):
            self.VALUE = self.VALUE * dispValue
        elif (anOp == "/"):
            if (dispValue == 0.0):
                error = 1
            else:
                self.VALUE = self.VALUE / dispValue
        elif (anOp == "%"):
            self.VALUE = self.VALUE * dispValue / 100

        self.DISPLAY = QString("")
        if (error > 0):
            self.lcDisplay.display(QString("error"))
        else:
            self.lcDisplay.display(QString("").setNum(self.VALUE, 'f', 2))


    def handleButton0(self):
        self.handleValue(0)
    def handleButton1(self):
        self.handleValue(1)
    def handleButton2(self):
        self.handleValue(2)
    def handleButton3(self):
        self.handleValue(3)
    def handleButton4(self):
        self.handleValue(4)
    def handleButton5(self):
        self.handleValue(5)
    def handleButton6(self):
        self.handleValue(6)
    def handleButton7(self):
        self.handleValue(7)
    def handleButton8(self):
        self.handleValue(8)
    def handleButton9(self):
        self.handleValue(9)
    def handleButton00(self):
        self.handleValue(0)
        self.handleValue(0)

    def handleButtonDot(self):
        if (self.DISPLAY.find(".") < 0):
            self.DISPLAY.append(".")
            self.lcDisplay.display(self.DISPLAY)

    def handleButtonPlus(self):
        self.handleOperation("+")
    def handleButtonMinus(self):
        self.handleOperation("-")
    def handleButtonMultiplicate(self):
        self.handleOperation("*")
    def handleButtonDivide(self):
        self.handleOperation("/")
    def handleButtonPercent(self):
        self.handleOperation("%")

    def handleButtonEnter(self):
        self.insertLine("=", QString("").setNum(self.VALUE, 'f', 2))
        self.insertLine("", "")
        self.VALUE = 0.0

    def handleButtonClear(self):
        self.insertLine("", "")
        self.insertLine("C", "0")
        self.VALUE = 0.0
        self.DISPLAY = QString("")
        self.lcDisplay.display("0")


