
import os
import kumula
from qt import *
from IconSelectDialog import KIconSelectDialog
from AttrOptionSettingsTmpl import KAttrOptionSettingsTmpl


class KAttrOptionSettings(KAttrOptionSettingsTmpl):

    def __init__(self, parent):
        KAttrOptionSettingsTmpl.__init__(self, parent)
        self.btnIcon.setMinimumSize(QSize(80, 80))
        self.btnIcon.setMaximumSize(QSize(80, 80))
        self.iconDir = os.path.join(kumula.getIconDir(), "attricons")
        self.setOptionIcon("")


    def selectIcon(self):
        dlg = KIconSelectDialog(self, self.iconDir)
        if (dlg.exec_loop() == QDialog.Accepted):
            self.btnIcon.setPixmap(dlg.selectedPixmap())
            self.iconName = dlg.getIconName()


    def setOptionIcon(self, aName):
        self.iconName = QString(aName)
        if (aName == ""):
            self.btnIcon.setText("")
        else:
            self.btnIcon.setPixmap(QPixmap(os.path.join(self.iconDir, self.iconName.ascii() + ".png")))


    def getOptionIcon(self):
        return self.iconName

