
from AttributesDialogTmpl import KAttributesDialogTmpl
from qt import *
import kumula
from SpecialItems import KListViewItemWithID
from AttributeSettings import KAttributeSettings
from AttrOptionSettings import KAttrOptionSettings



class KAttributesDialog(KAttributesDialogTmpl):

    def __init__(self, parent, name = None,modal = 0,fl = 0):
        KAttributesDialogTmpl.__init__(self, parent)
        self.btnAttrNew.setIconSet(QIconSet(kumula.getIconByName("entry_new")))
        self.btnAttrEdit.setIconSet(QIconSet(kumula.getIconByName("entry_edit")))
        self.btnAttrDelete.setIconSet(QIconSet(kumula.getIconByName("entry_delete")))
        self.btnOptNew.setIconSet(QIconSet(kumula.getIconByName("entry_new")))
        self.btnOptEdit.setIconSet(QIconSet(kumula.getIconByName("entry_edit")))
        self.btnOptDelete.setIconSet(QIconSet(kumula.getIconByName("entry_delete")))
        self.lvAttributes.clear()
        self.lvOptions.clear()
        self.connect(self.lvAttributes, SIGNAL("selectionChanged()"), self.updateOptions)
        self.updateAttributes()


    def updateAttributes(self, selectedAttrID=-1):
        if (selectedAttrID < 0):
            selectedAttr = self.lvAttributes.currentItem()
            if (selectedAttr):
                selectedAttrID = selectedAttr.tag

        self.disconnect(self.lvAttributes, SIGNAL("selectionChanged()"), self.updateOptions)
        self.lvAttributes.clear()

        quAttr = kumula.DB.doSelect("clients_attributes", ("id","title","exclusive"), "title")
        foundAttr = 0
        while quAttr.next():
            myAttrID    = quAttr.value(0).toInt()
            myAttrTitle = quAttr.value(1).toString()
            myAttrExcl  = quAttr.value(2).toInt()
            item = KListViewItemWithID(self.lvAttributes, myAttrID)
            item.setText(0, myAttrTitle)
            if (myAttrID == selectedAttrID):
                foundAttr = 1
                self.lvAttributes.setSelected(item, 1)
                self.lvAttributes.setCurrentItem(item)
        firstItem = self.lvAttributes.firstChild()
        if (firstItem):
            if (foundAttr == 0):
                self.lvAttributes.setSelected(firstItem, 1)
                self.lvAttributes.setCurrentItem(firstItem)
            self.btnAttrEdit.setEnabled(1)
            self.btnAttrDelete.setEnabled(1)
            self.btnOptNew.setEnabled(1)
        else:
            # no attributes here
            self.btnAttrEdit.setEnabled(0)
            self.btnAttrDelete.setEnabled(0)
            self.btnOptNew.setEnabled(0)

        self.updateOptions()
        self.connect(self.lvAttributes, SIGNAL("selectionChanged()"), self.updateOptions)



    def updateOptions(self, selectedOptID=-1):
        if (selectedOptID < 0):
            selectedOpt = self.lvOptions.currentItem()
            if (selectedOpt):
                selectedOptID = selectedOpt.tag

        self.lvOptions.clear()
        selectedAttr = self.lvAttributes.currentItem()
        if (selectedAttr):
            selectedAttrID = self.lvAttributes.currentItem().tag
            quOpt = kumula.DB.doSelect("clients_attroptions", ("id","title"), "title", {"attrid":"%i" % selectedAttrID})
            foundOpt = 0
            while quOpt.next():
                myOptID    = quOpt.value(0).toInt()
                myOptTitle = quOpt.value(1).toString()
                item = KListViewItemWithID(self.lvOptions, myOptID)
                item.setText(0, myOptTitle)
                if (myOptID == selectedOptID):
                    foundOpt = 1
                    self.lvOptions.setSelected(item, 1)
                    self.lvOptions.setCurrentItem(item)
            firstItem = self.lvOptions.firstChild()
            if (firstItem):
                if (foundOpt == 0):
                    self.lvOptions.setSelected(firstItem, 1)
                    self.lvOptions.setCurrentItem(firstItem)
                self.btnOptEdit.setEnabled(1)
                self.btnOptDelete.setEnabled(1)
            else:
                # no options here
                self.btnOptEdit.setEnabled(0)
                self.btnOptDelete.setEnabled(0)
        else:
            # no attributes, ergo no options here
            self.btnOptEdit.setEnabled(0)
            self.btnOptDelete.setEnabled(0)




    def handleAttrNew(self):
        myNewID = -1
        dlg = KAttributeSettings(self)
        dlg.edTitle.setText(QString(""))
        dlg.cbExclusive.setChecked(0)
        if (dlg.exec_loop() == QDialog.Accepted):
            myTitle = dlg.edTitle.text()
            myExclusive = dlg.cbExclusive.isChecked()
            kumula.DB.doInsert("clients_attributes", {"title":myTitle, "exclusive":"%i" % myExclusive})
            myNewID = kumula.DB.lastAutoID()
        self.updateAttributes(myNewID)


    def handleAttrEdit(self):
        selectedAttr = self.lvAttributes.currentItem()
        if (selectedAttr):
            selectedAttrID = selectedAttr.tag
        else:
            return
        quAttr = kumula.DB.doSelect("clients_attributes", ("title","exclusive"), "id", {"id":"%i" % selectedAttrID})
        while quAttr.next():
            myTitle = quAttr.value(0).toString()
            myExclusive = quAttr.value(1).toInt()
        dlg = KAttributeSettings(self)
        dlg.edTitle.setText(myTitle)
        dlg.cbExclusive.setChecked(myExclusive)
        if (dlg.exec_loop() == QDialog.Accepted):
            myTitle = dlg.edTitle.text()
            myExclusive = dlg.cbExclusive.isChecked()
            kumula.DB.doUpdate("clients_attributes", {"title":myTitle,"exclusive":"%i" % myExclusive}, {"id":"%i" % selectedAttrID})
        self.updateAttributes(selectedAttrID)



    def handleAttrDelete(self):
        selectedAttr = self.lvAttributes.currentItem()
        if (selectedAttr):
            selectedAttrID = selectedAttr.tag
        else:
            return
        myQuestion = QString("Do you really want to<br>delete this attribute?<br><br><b>")
        myQuestion.append(self.lvAttributes.currentItem().text(0))
        myQuestion.append("</b><br><br>Warning! All options and assignments<br>to clients will also be deleted!")
        result = QMessageBox.warning(kumula.MainWin, "Question", myQuestion, "&Delete", "&Cancel")
        if (result == 0):
            kumula.DB.doDelete("clients_attroptions", {"attrid":"%i" % selectedAttrID})
            kumula.DB.doDelete("clients_attributes",  {"id":"%i" % selectedAttrID})
        self.updateAttributes()


    def handleOptNew(self):
        myNewID = -1
        dlg = KAttrOptionSettings(self)
        dlg.edTitle.setText(QString(""))
        if (dlg.exec_loop() == QDialog.Accepted):
            myTitle = dlg.edTitle.text()
            myIcon = dlg.getOptionIcon()
            kumula.DB.doInsert("clients_attroptions", {"attrid":"%i" % self.lvAttributes.currentItem().tag, "title":myTitle, "icon":myIcon})
            myNewID = kumula.DB.lastAutoID()
        self.updateOptions(myNewID)


    def handleOptEdit(self):
        selectedOpt = self.lvOptions.currentItem()
        if (selectedOpt):
            selectedOptID = selectedOpt.tag
        else:
            return
        quOpt = kumula.DB.doSelect("clients_attroptions", ("title","icon"), "id", {"id":"%i" % selectedOptID})
        while quOpt.next():
            myTitle = quOpt.value(0).toString()
            myIcon  = quOpt.value(1).toString()
        dlg = KAttrOptionSettings(self)
        dlg.edTitle.setText(myTitle)
        dlg.setOptionIcon(myIcon)
        if (dlg.exec_loop() == QDialog.Accepted):
            myTitle = dlg.edTitle.text()
            myIcon = dlg.getOptionIcon()
            kumula.DB.doUpdate("clients_attroptions", {"title":myTitle, "icon":dlg.getOptionIcon()}, {"id":"%i" % selectedOptID})
        self.updateOptions(selectedOptID)


    def handleOptDelete(self):
        selectedOpt = self.lvOptions.currentItem()
        if (selectedOpt):
            selectedOptID = selectedOpt.tag
        else:
            return
        myQuestion = QString("Do you really want to<br>delete this option?<br><br><b>")
        myQuestion.append(self.lvOptions.currentItem().text(0))
        myQuestion.append("</b><br><br>Warning! All assignments to clients<br>will also be deleted!")
        result = QMessageBox.warning(kumula.MainWin, "Question", myQuestion, "&Delete", "&Cancel")
        if (result == 0):
            kumula.DB.doDelete("clients_attroptions", {"id":"%i" % selectedOptID})
        self.updateOptions()

