# ============================================================
# ClientsDialog.py
# dialog for client setting (id, name, groups)...
# ------------------------------------------------------------
# Copyright (C) 2004 the Kumula Team.
# ============================================================

import kumula
from qt import *

# ------------------------------------------------------------


class KClientsDialog(QDialog):

    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        QDialog.__init__(self,parent,name,modal,fl)

        if not name:
            self.setName("ClientsDialog")


        ClientsDialogLayout = QGridLayout(self,1,1,11,6,"ClientsDialogLayout")

        self.lblID = QLabel(self,"lblID")
        ClientsDialogLayout.addWidget(self.lblID,0,0)
        self.lblName = QLabel(self,"lblName")
        ClientsDialogLayout.addWidget(self.lblName,1,0)
        self.lblGroups = QLabel(self,"lblGroups")
        ClientsDialogLayout.addWidget(self.lblGroups,2,0)
        self.edID = QLineEdit(self,"edID")
        self.edID.setMaxLength(15)
        ClientsDialogLayout.addWidget(self.edID,0,1)
        self.edName = QLineEdit(self,"edName")
        ClientsDialogLayout.addWidget(self.edName,1,1)
        self.lbGroups = QListBox(self, "lbGroups")
        self.lbGroups.setSelectionMode(QListBox.Multi)
        ClientsDialogLayout.addWidget(self.lbGroups,2,1)

        self.line1 = QFrame(self,"line1")
        self.line1.setFrameShape(QFrame.HLine)
        self.line1.setFrameShadow(QFrame.Sunken)
        self.line1.setFrameShape(QFrame.HLine)
        ClientsDialogLayout.addMultiCellWidget(self.line1,3,3,0,1)

        layout2 = QHBoxLayout(None,0,6,"layout2")
        self.btnOK = QPushButton(self,"btnOK")
        layout2.addWidget(self.btnOK)
        self.btnCancel = QPushButton(self,"btnCancel")
        layout2.addWidget(self.btnCancel)
        ClientsDialogLayout.addLayout(layout2,4,1)

        self.languageChange()

        self.resize(QSize(268,128).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.btnOK,SIGNAL("clicked()"),self,SLOT("accept()"))
        self.connect(self.btnCancel,SIGNAL("clicked()"),self,SLOT("reject()"))

        self.setTabOrder(self.edID,self.edName)
        self.setTabOrder(self.edName,self.lbGroups)
        self.setTabOrder(self.lbGroups,self.btnOK)
        self.setTabOrder(self.btnOK,self.btnCancel)


    def languageChange(self):
        self.setCaption(self.__tr("Edit client"))
        self.lblName.setText(self.__tr("Client's name:"))
        self.lblGroups.setText(self.__tr("Belongs to group(s):"))
        self.lblID.setText(self.__tr("Client's ID:"))
        self.btnOK.setText(self.__tr("&OK"))
        self.btnOK.setAccel(self.__tr("Alt+O"))
        self.btnCancel.setText(self.__tr("&Cancel"))
        self.btnCancel.setAccel(self.__tr("Alt+C"))


    def __tr(self,s,c = None):
        return qApp.translate("ClientsDialog",s,c)
