# ============================================================
# GroupsDialog.py
# dialog for group settings (name, folder color)...
# ------------------------------------------------------------
# Copyright (C) 2004 the Kumula Team.
# ============================================================

from qt import *

# ------------------------------------------------------------


class KGroupsDialog(QDialog):

    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        QDialog.__init__(self,parent,name,modal,fl)

        if not name:
            self.setName("QGroupsDialog")

        GroupDialogLayout = QGridLayout(self,1,1,11,6,"GroupDialogLayout")

        self.lblColor = QLabel(self,"lblColor")
        GroupDialogLayout.addWidget(self.lblColor,1,0)
        self.lblName = QLabel(self,"lblName")
        GroupDialogLayout.addWidget(self.lblName,0,0)

        self.line1 = QFrame(self,"line1")
        self.line1.setFrameShape(QFrame.HLine)
        self.line1.setFrameShadow(QFrame.Sunken)
        self.line1.setFrameShape(QFrame.HLine)
        GroupDialogLayout.addMultiCellWidget(self.line1,2,2,0,2)

        self.btnCancel = QPushButton(self,"btnCancel")
        GroupDialogLayout.addWidget(self.btnCancel,3,2)

        self.cbColor = QComboBox(0,self,"cbColor")
        GroupDialogLayout.addMultiCellWidget(self.cbColor,1,1,1,2)

        self.edName = QLineEdit(self,"edName")
        GroupDialogLayout.addMultiCellWidget(self.edName,0,0,1,2)

        self.btnOK = QPushButton(self,"btnOK")
        self.btnOK.setDefault(1)
        GroupDialogLayout.addWidget(self.btnOK,3,1)

        self.languageChange()

        self.resize(QSize(327,146).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.btnOK,SIGNAL("clicked()"),self,SLOT("accept()"))
        self.connect(self.btnCancel,SIGNAL("clicked()"),self,SLOT("reject()"))

        self.setTabOrder(self.edName,self.cbColor)
        self.setTabOrder(self.cbColor,self.btnOK)
        self.setTabOrder(self.btnOK,self.btnCancel)


    def languageChange(self):
        self.setCaption(self.__tr("Group settings"))
        self.lblColor.setText(self.__tr("Color of folder icon:"))
        self.lblName.setText(self.__tr("Name of group:"))
        self.btnCancel.setText(self.__tr("&Cancel"))
        self.btnCancel.setAccel(self.__tr("Alt+C"))
        self.cbColor.clear()
        self.cbColor.insertItem(self.__tr("blue"))
        self.cbColor.insertItem(self.__tr("violet"))
        self.cbColor.insertItem(self.__tr("red"))
        self.cbColor.insertItem(self.__tr("orange"))
        self.cbColor.insertItem(self.__tr("yellow"))
        self.cbColor.insertItem(self.__tr("green"))
        self.cbColor.insertItem(self.__tr("grey"))
        self.btnOK.setText(self.__tr("&OK"))
        self.btnOK.setAccel(self.__tr("Alt+O"))


    def __tr(self,s,c = None):
        return qApp.translate("GroupDialog",s,c)
