# ============================================================
# CommunicationsDialog.py
# dialog for communication data (phone, fax, email, ...)
# ------------------------------------------------------------
# Copyright (C) 2004 the Kumula Team.
# ============================================================

import kumula
from qt import *

# ------------------------------------------------------------


CommunicationTypes = QString("Phone;Fax;Mobile;Homepage;Email;Instant Messenger")


class KCommunicationsDialog(QDialog):


    def __init__(self):
        QDialog.__init__(self, kumula.MainWin, "CommunicationsDialog", 1, 0)
        Form1Layout = QGridLayout(self,1,1,11,6,"Form1Layout")

        self.textLabel1 = QLabel(self,"textLabel1")
        Form1Layout.addWidget(self.textLabel1,0,0)

        self.textLabel2 = QLabel(self,"textLabel2")
        Form1Layout.addWidget(self.textLabel2,1,0)

        self.edValue = QLineEdit(self,"edValue")
        Form1Layout.addMultiCellWidget(self.edValue,1,1,1,2)

        self.cbCommType = QComboBox(0,self,"cbCommType")
        Form1Layout.addMultiCellWidget(self.cbCommType,0,0,1,2)

        self.line1 = QFrame(self,"line1")
        self.line1.setFrameShape(QFrame.HLine)
        self.line1.setFrameShadow(QFrame.Sunken)
        self.line1.setFrameShape(QFrame.HLine)
        Form1Layout.addMultiCellWidget(self.line1,2,2,0,2)

        self.btOK = QPushButton(self,"btOK")
        Form1Layout.addWidget(self.btOK,3,1)
        self.btOK.default = 1

        self.btCancel = QPushButton(self,"btCancel")
        Form1Layout.addWidget(self.btCancel,3,2)

        self.languageChange()

        self.resize(QSize(299,131).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.btOK,     SIGNAL("clicked()"), self, SLOT("accept()"))
        self.connect(self.btCancel, SIGNAL("clicked()"), self, SLOT("reject()"))

        self.setTabOrder(self.cbCommType,self.edValue)
        self.setTabOrder(self.edValue,self.btOK)
        self.setTabOrder(self.btOK,self.btCancel)


    def languageChange(self):

        self.setCaption("Communication data")
        self.textLabel1.setText("Communication type:")
        self.textLabel2.setText("Number/Address/Value:")

        myItems = QStringList.split(QChar(";"), CommunicationTypes)
        self.cbCommType.clear()
        self.cbCommType.insertStringList(myItems)

        self.btOK.setText("&OK")
#        self.btOK.setAccel("Alt+O")
        self.btCancel.setText("&Cancel")
#        self.btCancel.setAccel("Alt+C")

