# ============================================================
# ContactPersonDialog.py
# dialog for personal data (name, function, birthday, ...)
# ------------------------------------------------------------
# Copyright (C) 2004 the Kumula Team.
# ============================================================

import kumula
from qt import *
from CommunicationsDialog import KCommunicationsDialog
from CommunicationsDialog import CommunicationTypes
from SpecialItems import KListViewItemWithID

# ------------------------------------------------------------

    
class KContactPersonDialog(QDialog):


    def __init__(self, parent):
        QDialog.__init__(self, parent, "ContactPersonDialog", 0, 0)

        self.image0 = kumula.getIconByName("entry_new")
        self.image1 = kumula.getIconByName("entry_edit")
        self.image2 = kumula.getIconByName("entry_delete")

        KContactPersonDialogLayout = QVBoxLayout(self,11,6,"KContactPersonDialogLayout")
        layout23 = QHBoxLayout(None,0,6,"layout23")
        layout9 = QVBoxLayout(None,0,6,"layout9")
        layout8 = QGridLayout(None,1,1,0,6,"layout8")

        self.textLabel3 = QLabel(self,"textLabel3")
        layout8.addWidget(self.textLabel3,0,1)

        self.textLabel1_2 = QLabel(self,"textLabel1_2")
        layout8.addWidget(self.textLabel1_2,0,0)

        self.edBirthday = QDateEdit(self,"edBirthday")
        layout8.addWidget(self.edBirthday,1,1)

        self.edTitle = QLineEdit(self,"edTitle")
        layout8.addWidget(self.edTitle,1,0)
        layout9.addLayout(layout8)

        spacer1 = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Expanding)
        layout9.addItem(spacer1)

        layout7 = QGridLayout(None,1,1,0,6,"layout7")

        self.edName = QLineEdit(self,"edName")
        layout7.addWidget(self.edName,1,0)

        self.textLabel1_2_2 = QLabel(self,"textLabel1_2_2")
        layout7.addWidget(self.textLabel1_2_2,0,1)

        self.textLabel1 = QLabel(self,"textLabel1")
        layout7.addWidget(self.textLabel1,0,0)

        self.edForename = QLineEdit(self,"edForename")
        layout7.addWidget(self.edForename,1,1)

        layout9.addLayout(layout7)
        spacer2 = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Expanding)
        layout9.addItem(spacer2)

        layout6 = QVBoxLayout(None,0,6,"layout6")
        self.textLabel2 = QLabel(self,"textLabel2")
        layout6.addWidget(self.textLabel2)
        self.edFunction = QLineEdit(self,"edFunction")
        layout6.addWidget(self.edFunction)
        layout9.addLayout(layout6)

        spacer32 = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Expanding)
        layout9.addItem(spacer32)

        layout36 = QVBoxLayout(None,0,6,"layout36")
        self.textLabel32 = QLabel(self,"textLabel32")
        layout36.addWidget(self.textLabel32)
        self.edDivision = QLineEdit(self,"edDivision")
        layout36.addWidget(self.edDivision)
        layout9.addLayout(layout36)

        layout23.addLayout(layout9)

        self.line2 = QFrame(self,"line2")
        self.line2.setFrameShape(QFrame.VLine)
        self.line2.setFrameShadow(QFrame.Sunken)
        self.line2.setFrameShape(QFrame.VLine)
        layout23.addWidget(self.line2)

        layout22 = QVBoxLayout(None,0,6,"layout22")

        self.lvAddress = QListView(self,"lvAddress")
        self.lvAddress.addColumn(self.__tr("Assigned office address:"))
        self.lvAddress.setAllColumnsShowFocus(1)
        self.lvAddress.setResizeMode(QListView.LastColumn)
        layout22.addWidget(self.lvAddress)

        self.line1 = QFrame(self,"line1")
        self.line1.setFrameShape(QFrame.HLine)
        self.line1.setFrameShadow(QFrame.Sunken)
        self.line1.setFrameShape(QFrame.HLine)
        layout22.addWidget(self.line1)

        layout21 = QVBoxLayout(None,0,6,"layout21")

        self.textLabel5 = QLabel(self,"textLabel5")
        layout21.addWidget(self.textLabel5)

        layout20 = QHBoxLayout(None,0,6,"layout20")

        self.lvCommunications = QListView(self,"lvCommunications")
        self.lvCommunications.addColumn(self.__tr("Type"))
        self.lvCommunications.addColumn(self.__tr("Number/Address"))
        self.lvCommunications.setAllColumnsShowFocus(1)
        self.lvCommunications.setResizeMode(QListView.LastColumn)
        layout20.addWidget(self.lvCommunications)

        layout19 = QVBoxLayout(None,0,6,"layout19")

        self.btnCommNew = QPushButton(self,"btnCommNew")
        self.btnCommNew.setPixmap(self.image0)
        layout19.addWidget(self.btnCommNew)
        spacer5 = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Expanding)
        layout19.addItem(spacer5)

        self.btnCommEdit = QPushButton(self,"btnCommEdit")
        self.btnCommEdit.setPixmap(self.image1)
        layout19.addWidget(self.btnCommEdit)
        spacer5_2 = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Expanding)
        layout19.addItem(spacer5_2)

        self.btnCommDel = QPushButton(self,"btnCommDel")
        self.btnCommDel.setPixmap(self.image2)
        layout19.addWidget(self.btnCommDel)
        layout20.addLayout(layout19)
        layout21.addLayout(layout20)
        layout22.addLayout(layout21)
        layout23.addLayout(layout22)
        KContactPersonDialogLayout.addLayout(layout23)

        self.line3 = QFrame(self,"line3")
        self.line3.setFrameShape(QFrame.HLine)
        self.line3.setFrameShadow(QFrame.Sunken)
        self.line3.setFrameShape(QFrame.HLine)
        KContactPersonDialogLayout.addWidget(self.line3)

        layout12 = QHBoxLayout(None,0,6,"layout12")
        spacer4 = QSpacerItem(230,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout12.addItem(spacer4)

        self.btnOK = QPushButton(self,"btnOK")
        self.btnOK.setDefault(1)
        layout12.addWidget(self.btnOK)

        self.btnCancel = QPushButton(self,"btnCancel")
        layout12.addWidget(self.btnCancel)
        KContactPersonDialogLayout.addLayout(layout12)

        self.languageChange()

        self.resize(QSize(483,267).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.btnCommNew,SIGNAL("clicked()"),self.newComm)
        self.connect(self.btnCommEdit,SIGNAL("clicked()"),self.editComm)
        self.connect(self.btnCommDel,SIGNAL("clicked()"),self.delComm)
        self.connect(self.btnOK,SIGNAL("clicked()"),self,SLOT("accept()"))
        self.connect(self.btnCancel,SIGNAL("clicked()"),self,SLOT("reject()"))

        self.setTabOrder(self.edTitle,self.edBirthday)
        self.setTabOrder(self.edBirthday,self.edName)
        self.setTabOrder(self.edName,self.edForename)
        self.setTabOrder(self.edForename,self.edFunction)
        self.setTabOrder(self.edFunction,self.edDivision)
        self.setTabOrder(self.edDivision,self.lvAddress)
        self.setTabOrder(self.lvAddress,self.lvCommunications)
        self.setTabOrder(self.lvCommunications,self.btnCommNew)
        self.setTabOrder(self.btnCommNew,self.btnCommEdit)
        self.setTabOrder(self.btnCommEdit,self.btnCommDel)
        self.setTabOrder(self.btnCommDel,self.btnOK)
        self.setTabOrder(self.btnOK,self.btnCancel)




    def makeListViewItem(self, parent, title, tag, selTag):
        item = KListViewItemWithID(self.lvAddress, tag)
        item.setText(0, title)
        if (tag == selTag):
            parent.setSelected(item, 1)
            parent.setCurrentItem(item)
        return item


    def setAddressesFromContact(self, clID, contactID=""):
        ContactAddressID = "0"
        if (contactID != ""):
            quAddress = kumula.DB.doSelect("clients_contacts", ("addressid",), "", {"clientid":clID, "id":contactID}, 1)
            if quAddress.next():
                ContactAddressID = quAddress.value(0).toString()
        self.lvAddress.clear()
        self.makeListViewItem(self.lvAddress, "(unknown)",   "0", ContactAddressID)
        self.makeListViewItem(self.lvAddress, "(external)", "-1", ContactAddressID)
        quAddresses = kumula.DB.doSelect("clients_addresses", ("id","comment"), "", {"clientid":clID})
        while quAddresses.next():
            self.makeListViewItem(self.lvAddress, quAddresses.value(1).toString(), quAddresses.value(0).toString(), ContactAddressID)



    def setCommunicationsFromContact(self, clID, contactID):
        self.lvCommunications.clear()
        self.CommTypes = QStringList.split(QChar(";"), CommunicationTypes)
        quComms = kumula.DB.doSelect("clients_communications", ("type","value"), "type", {"clientid":clID, "contactid":contactID})
        while quComms.next():
            comm = quComms.value(0).toInt()
            item = KListViewItemWithID(self.lvCommunications, comm)
            item.setText(0, self.CommTypes[comm])
            item.setText(1, quComms.value(1).toString())
        self.lvCommunications.setSelected(self.lvCommunications.firstChild(), 1)
        self.lvCommunications.setCurrentItem(self.lvCommunications.firstChild())
    

    
    def writeCommunicationsToDB(self, clID, contactID):
        kumula.DB.doDelete("clients_communications", {"clientid":clID, "contactid":contactID})
        item = self.lvCommunications.firstChild()
        while (item):
            kumula.DB.doInsert("clients_communications", {"clientid":clID, "contactid":contactID, "type":"%i" % item.tag, "value":item.text(1)})
            item = item.nextSibling()



    def languageChange(self):
        self.setCaption(self.__tr("Contact Person"))
        self.textLabel3.setText(self.__tr("Birthday:"))
        self.textLabel1_2.setText(self.__tr("Title:"))
        self.textLabel1_2_2.setText(self.__tr("Forename:"))
        self.textLabel1.setText(self.__tr("Name:"))
        self.textLabel2.setText(self.__tr("Function:"))
        self.textLabel32.setText(self.__tr("Division:"))
        self.textLabel5.setText(self.__tr("Individual communication data:"))
        self.lvCommunications.header().setLabel(0,self.__tr("Type"))
        self.lvCommunications.header().setLabel(1,self.__tr("Number/Address"))
        self.btnCommNew.setText(QString.null)
        self.btnCommEdit.setText(QString.null)
        self.btnCommDel.setText(QString.null)
        self.btnOK.setText(self.__tr("&OK"))
        self.btnOK.setAccel(self.__tr("Alt+O"))
        self.btnCancel.setText(self.__tr("&Cancel"))
        self.btnCancel.setAccel(self.__tr("Alt+C"))


    def newComm(self):
        dlg = KCommunicationsDialog()
        dlg.cbCommType.setCurrentItem(0)
        dlg.edValue.setText("")
        if dlg.exec_loop() == QDialog.Accepted:
            comm = dlg.cbCommType.currentItem()
            item = KListViewItemWithID(self.lvCommunications, comm)
            item.setText(0, self.CommTypes[comm])
            item.setText(1, dlg.edValue.text())
            self.lvCommunications.setSelected(item, 1)
            self.lvCommunications.setCurrentItem(item)



    def editComm(self):
        myItem = self.lvCommunications.currentItem()
        if (myItem):
            dlg = KCommunicationsDialog()
            dlg.cbCommType.setCurrentItem(myItem.tag)
            dlg.edValue.setText(myItem.text(1))
            if dlg.exec_loop() == QDialog.Accepted:
                comm = dlg.cbCommType.currentItem()
                myItem.tag = comm
                myItem.setText(0, self.CommTypes[comm])
                myItem.setText(1, dlg.edValue.text())

    
    
    def delComm(self):
        myItem = self.lvCommunications.currentItem()
        if (myItem):
            self.lvCommunications.takeItem(self.lvCommunications.currentItem())
            self.lvCommunications.setSelected(self.lvCommunications.firstChild(), 1)
            self.lvCommunications.setCurrentItem(self.lvCommunications.firstChild())



    
    
    def __tr(self,s,c = None):
        return qApp.translate("KContactPersonDialog",s,c)
