# ============================================================
# TicketSettingsDialog.py
# dialog for setting options for the TICKETS plugin.
# ------------------------------------------------------------
# Copyright (C) 2004 the Kumula Team.
# ============================================================

from qt import *

# ------------------------------------------------------------

class KContactsSettingsDialog(QDialog):

    def __init__(self,parent = None,name = None,modal = 0,fl = 0):

        QDialog.__init__(self,parent,name,modal,fl)

        if not name:
            self.setName("ContactsSettingsDialog")


        ContactsSettingsDialogLayout = QGridLayout(self,1,1,11,6,"ContactsSettingsDialogLayout")

        self.cbContactPersons = QCheckBox(self,"cbContactPersons")

        ContactsSettingsDialogLayout.addMultiCellWidget(self.cbContactPersons,0,0,0,3)
        spacer1 = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Expanding)
        ContactsSettingsDialogLayout.addItem(spacer1,5,1)
        spacer2 = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Expanding)
        ContactsSettingsDialogLayout.addItem(spacer2,7,1)

        self.cbContactPhoto = QCheckBox(self,"cbContactPhoto")

        ContactsSettingsDialogLayout.addMultiCellWidget(self.cbContactPhoto,1,1,1,3)

        self.cbContactFunction = QCheckBox(self,"cbContactFunction")

        ContactsSettingsDialogLayout.addMultiCellWidget(self.cbContactFunction,2,2,1,3)

        self.cbContactEmail = QCheckBox(self,"cbContactEmail")

        ContactsSettingsDialogLayout.addMultiCellWidget(self.cbContactEmail,3,3,1,3)

        self.cbContactMobile = QCheckBox(self,"cbContactMobile")

        ContactsSettingsDialogLayout.addMultiCellWidget(self.cbContactMobile,4,4,1,3)

        self.frame3 = QFrame(self,"frame3")
        self.frame3.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Expanding,0,0,self.frame3.sizePolicy().hasHeightForWidth()))
        self.frame3.setMinimumSize(QSize(30,0))
        self.frame3.setFrameShape(QFrame.StyledPanel)
        self.frame3.setFrameShadow(QFrame.Raised)
        self.frame3.setLineWidth(-1)

        ContactsSettingsDialogLayout.addMultiCellWidget(self.frame3,1,4,0,0)

        self.frame3_2 = QFrame(self,"frame3_2")
        self.frame3_2.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Expanding,0,0,self.frame3_2.sizePolicy().hasHeightForWidth()))
        self.frame3_2.setMinimumSize(QSize(30,0))
        self.frame3_2.setFrameShape(QFrame.StyledPanel)
        self.frame3_2.setFrameShadow(QFrame.Raised)
        self.frame3_2.setLineWidth(0)

        ContactsSettingsDialogLayout.addWidget(self.frame3_2,9,0)

        self.cbCommunications = QCheckBox(self,"cbCommunications")

        ContactsSettingsDialogLayout.addMultiCellWidget(self.cbCommunications,6,6,0,3)

        self.cbAddresses = QCheckBox(self,"cbAddresses")

        ContactsSettingsDialogLayout.addMultiCellWidget(self.cbAddresses,8,8,0,3)

        self.cbAddressesFull = QCheckBox(self,"cbAddressesFull")

        ContactsSettingsDialogLayout.addMultiCellWidget(self.cbAddressesFull,9,9,1,3)

        self.line1 = QFrame(self,"line1")
        self.line1.setFrameShape(QFrame.HLine)
        self.line1.setFrameShadow(QFrame.Sunken)
        self.line1.setFrameShape(QFrame.HLine)

        ContactsSettingsDialogLayout.addMultiCellWidget(self.line1,10,10,0,3)

        self.line2 = QFrame(self,"line2")
        self.line2.setFrameShape(QFrame.HLine)
        self.line2.setFrameShadow(QFrame.Sunken)
        self.line2.setFrameShape(QFrame.HLine)

        ContactsSettingsDialogLayout.addMultiCellWidget(self.line2,12,12,0,3)

        self.cbSpacing = QCheckBox(self,"cbSpacing")

        ContactsSettingsDialogLayout.addMultiCellWidget(self.cbSpacing,11,11,0,3)

        self.btnOK = QPushButton(self,"btnOK")
        self.btnOK.setDefault(1)

        ContactsSettingsDialogLayout.addWidget(self.btnOK,13,2)
        spacer3 = QSpacerItem(220,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        ContactsSettingsDialogLayout.addMultiCell(spacer3,13,13,0,1)

        self.btnCancel = QPushButton(self,"btnCancel")

        ContactsSettingsDialogLayout.addWidget(self.btnCancel,13,3)

        self.languageChange()

        self.resize(QSize(315,329).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.btnOK,SIGNAL("clicked()"),self,SLOT("accept()"))
        self.connect(self.btnCancel,SIGNAL("clicked()"),self,SLOT("reject()"))
        self.connect(self.cbContactPersons,SIGNAL("toggled(bool)"),self.updateCheckBoxes)
        self.connect(self.cbAddresses,SIGNAL("toggled(bool)"),self.updateCheckBoxes)

        self.setTabOrder(self.cbContactPersons,self.cbContactPhoto)
        self.setTabOrder(self.cbContactPhoto,self.cbContactFunction)
        self.setTabOrder(self.cbContactFunction,self.cbContactEmail)
        self.setTabOrder(self.cbContactEmail,self.cbContactMobile)
        self.setTabOrder(self.cbContactMobile,self.cbCommunications)
        self.setTabOrder(self.cbCommunications,self.cbAddresses)
        self.setTabOrder(self.cbAddresses,self.cbAddressesFull)
        self.setTabOrder(self.cbAddressesFull,self.cbSpacing)
        self.setTabOrder(self.cbSpacing,self.btnOK)
        self.setTabOrder(self.btnOK,self.btnCancel)

        self.updateCheckBoxes()


    def languageChange(self):
        self.setCaption(self.__tr("Configure Contacts view"))
        self.cbContactPersons.setText(self.__tr("Show contact persons"))
        self.cbContactPhoto.setText(self.__tr("Show photo for each contact person"))
        self.cbContactFunction.setText(self.__tr("Show function/division info, if available"))
        self.cbContactEmail.setText(self.__tr("Show personal Email address, if available"))
        self.cbContactMobile.setText(self.__tr("Show personal mobile number, if available"))
        self.cbCommunications.setText(self.__tr("Show communication data"))
        self.cbAddresses.setText(self.__tr("Show addresses"))
        self.cbAddressesFull.setText(self.__tr("Show full addresses (including header data)"))
        self.cbSpacing.setText(self.__tr("Use spacing between entries"))
        self.btnOK.setText(self.__tr("&OK"))
        self.btnOK.setAccel(self.__tr("Alt+O"))
        self.btnCancel.setText(self.__tr("&Cancel"))
        self.btnCancel.setAccel(self.__tr("Alt+C"))


    def updateCheckBoxes(self):
        if (self.cbContactPersons.isChecked()):
            self.cbContactPhoto.setEnabled(1)
            self.cbContactFunction.setEnabled(1)
            self.cbContactEmail.setEnabled(1)
            self.cbContactMobile.setEnabled(1)
        else:
            self.cbContactPhoto.setEnabled(0)
            self.cbContactFunction.setEnabled(0)
            self.cbContactEmail.setEnabled(0)
            self.cbContactMobile.setEnabled(0)

        if (self.cbAddresses.isChecked()):
            self.cbAddressesFull.setEnabled(1)
        else:
            self.cbAddressesFull.setEnabled(0)


    def __tr(self,s,c = None):
        return qApp.translate("ContactsSettingsDialog",s,c)
