# ============================================================
# TicketDialog.py
# dialog for posting messages and replies
# ------------------------------------------------------------
# Copyright (C) 2004 the Kumula Team.
# ============================================================

from qt import *

# ------------------------------------------------------------


class KTicketDialog(QDialog):

    def __init__(self,parent):

        QDialog.__init__(self, parent, "TicketDialog", 0, 0)
        TicketDialogLayout = QGridLayout(self,1,1,11,6,"TicketDialogLayout")

        self.textLabel1 = QLabel(self,"textLabel1")
        TicketDialogLayout.addWidget(self.textLabel1,0,0)
        self.textLabel2 = QLabel(self,"textLabel2")
        TicketDialogLayout.addWidget(self.textLabel2,2,0)

        self.line1 = QFrame(self,"line1")
        self.line1.setFrameShape(QFrame.HLine)
        self.line1.setFrameShadow(QFrame.Sunken)
        self.line1.setFrameShape(QFrame.HLine)
        TicketDialogLayout.addMultiCellWidget(self.line1,4,4,0,2)

        self.edSubject = QLineEdit(self,"edSubject")
        TicketDialogLayout.addMultiCellWidget(self.edSubject,1,1,0,2)

        self.edMessage = QTextEdit(self,"edMessage")
        TicketDialogLayout.addMultiCellWidget(self.edMessage,3,3,0,2)

        self.btnCancel = QPushButton(self,"btnCancel")
        TicketDialogLayout.addWidget(self.btnCancel,5,2)
        self.btnOK = QPushButton(self,"btnOK")
        self.btnOK.setDefault(1)
        TicketDialogLayout.addWidget(self.btnOK,5,1)
        spacer1 = QSpacerItem(40,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        TicketDialogLayout.addItem(spacer1,5,0)

        self.languageChange()

        self.resize(QSize(343,276).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.btnOK,SIGNAL("clicked()"),self,SLOT("accept()"))
        self.connect(self.btnCancel,SIGNAL("clicked()"),self,SLOT("reject()"))

        self.setTabOrder(self.edSubject,self.edMessage)
        self.setTabOrder(self.edMessage,self.btnOK)
        self.setTabOrder(self.btnOK,self.btnCancel)


    def languageChange(self):
        self.setCaption(self.__tr("Post message"))
        self.textLabel1.setText(self.__tr("Subject:"))
        self.textLabel2.setText(self.__tr("Message:"))
        self.btnCancel.setText(self.__tr("&Cancel"))
        self.btnCancel.setAccel(self.__tr("Alt+C"))
        self.btnOK.setText(self.__tr("&Post"))
        self.btnOK.setAccel(self.__tr("Alt+P"))


    def __tr(self,s,c = None):
        return qApp.translate("TicketDialog",s,c)
