# ============================================================
# TicketSettingsDialog.py
# dialog for setting options for the TICKETS plugin.
# ------------------------------------------------------------
# Copyright (C) 2004 the Kumula Team.
# ============================================================

from qt import *

# ------------------------------------------------------------


class KTicketSettingsDialog(QDialog):

    def __init__(self,parent = None):
        QDialog.__init__(self,parent, "TicketSettingsDialog", 1, 0)
        TicketSettingsDialogLayout = QVBoxLayout(self,11,6,"TicketSettingsDialogLayout")

        self.bgView = QButtonGroup(self,"bgView")
        self.bgView.setColumnLayout(0,Qt.Vertical)
        self.bgView.layout().setSpacing(6)
        self.bgView.layout().setMargin(11)
        bgViewLayout = QVBoxLayout(self.bgView.layout())
        bgViewLayout.setAlignment(Qt.AlignTop)

        self.rbComplete = QRadioButton(self.bgView,"rbComplete")
        self.rbComplete.setChecked(1)
        bgViewLayout.addWidget(self.rbComplete)

        self.rbFollowUps = QRadioButton(self.bgView,"rbFollowUps")
        bgViewLayout.addWidget(self.rbFollowUps)
        TicketSettingsDialogLayout.addWidget(self.bgView)

        self.aLine = QFrame(self,"aLine")
        self.aLine.setFrameShape(QFrame.HLine)
        self.aLine.setFrameShadow(QFrame.Sunken)
        self.aLine.setFrameShape(QFrame.HLine)
        TicketSettingsDialogLayout.addWidget(self.aLine)

        layout1 = QHBoxLayout(None,0,6,"layout1")
        aSpacer = QSpacerItem(40,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout1.addItem(aSpacer)

        self.btnOK = QPushButton(self,"btnOK")
        layout1.addWidget(self.btnOK)

        self.btnCancel = QPushButton(self,"btnCancel")
        layout1.addWidget(self.btnCancel)
        TicketSettingsDialogLayout.addLayout(layout1)

        self.languageChange()

        self.resize(QSize(313,147).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.btnOK,SIGNAL("clicked()"),self,SLOT("accept()"))
        self.connect(self.btnCancel,SIGNAL("clicked()"),self,SLOT("reject()"))

        self.setTabOrder(self.rbComplete,self.btnOK)
        self.setTabOrder(self.btnOK,self.btnCancel)


    def languageChange(self):
        self.setCaption(self.__tr("Ticket settings"))
        self.bgView.setTitle(self.__tr("Thread view:"))
        self.rbComplete.setText(self.__tr("show complete thread in message view"))
        self.rbFollowUps.setText(self.__tr("show only follow-ups in message view"))
        self.btnOK.setText(self.__tr("&OK"))
        self.btnOK.setAccel(self.__tr("Alt+O"))
        self.btnCancel.setText(self.__tr("&Cancel"))
        self.btnCancel.setAccel(self.__tr("Alt+C"))


    def __tr(self,s,c = None):
        return qApp.translate("TicketSettingsDialog",s,c)
