

from widgetTmpl_language import WidgetLanguage
import kumula


class ConfigWidget(WidgetLanguage):

    def __init__(self, parent):
        WidgetLanguage.__init__(self, parent)
        self.setIcon(kumula.getSideBarIcon("languages"))


    def getDescription(self):
        myDesc = "Please select your preferred language."
        return myDesc

    def getSectionName(self):
        return "language"

    def getValues(self):
        myLang = ""
        if self.rbSpanish.isOn():
            myLang = "ES"
        if self.rbGerman.isOn():
            myLang = "DE"
        if self.rbEnglish.isOn():
            myLang = "EN"

        myValues = {
            "lang":myLang
        }
        return myValues


    def setValues(self, aValueDict):
        myLang = aValueDict["lang"]
        if (myLang == "EN"):
            self.rbEnglish.setChecked(1)
        elif (myLang == "DE"):
            self.rbGerman.setChecked(1)
        elif (myLang == "ES"):
            self.rbSpanish.setChecked(1)


    def getDefaultValues(self):
        myValues = {
            "lang":"EN"
        }
        return myValues
