

from widgetTmpl_database import WidgetDatabase
from qt import QMessageBox
import kumula


class ConfigWidget(WidgetDatabase):

    def __init__(self, parent):
        WidgetDatabase.__init__(self, parent)
        self.setIcon(kumula.getSideBarIcon("database"))


    def getDescription(self):
        myDesc = "Warning! This data should only be modified by a system administrator."
        return myDesc

    def getSectionName(self):
        return "database"

    def getValues(self):
        if (self.cbType.currentItem() == 0):
            myType = "QMYSQL3"
        else:
            myType = "QPGSQL3"

        myValues = {
            "host":self.edHost.text(),
            "port":self.edPort.value(),
            "name":self.edName.text(),
            "user":self.edUser.text(),
            "pass":self.edPass.text(),
            "type":myType
        }
        return myValues


    def setValues(self, aValueDict):
        self.edHost.setText(aValueDict["host"])
        self.edPort.setValue(int(aValueDict["port"]))
        self.edName.setText(aValueDict["name"])
        self.edUser.setText(aValueDict["user"])
        self.edPass.setText(aValueDict["pass"])
        if (aValueDict["type"] == "QMYSQL3"):
            self.cbType.setCurrentItem(0)
        else:
            self.cbType.setCurrentItem(1)


    def getDefaultValues(self):
        myValues = {
            "host":"localhost",
            "port":"3306",
            "name":"kumula",
            "user":"kumula",
            "pass":"",
            "type":"QMYSQL3"
        }
        return myValues


    def testConnectivity(self):
        curValues = self.getValues()
        kumula.DBHost = curValues["host"]
        kumula.DBPort = curValues["port"]
        kumula.DBName = curValues["name"]
        kumula.DBUser = curValues["user"]
        kumula.DBPass = curValues["pass"]
        kumula.DBType = curValues["type"]
        result = kumula.initDatabase()
        if (result == 1):
            QMessageBox.information(kumula.MainWin, "Information", "Database access<br>was successful!")
        # else clause is not needed,
        # kumula.initDatabase() displays an error message automatically if database access fails.

