

from widgetTmpl_ui import WidgetUI
from qt import QString
import kumula
import sys
import os


class ConfigWidget(WidgetUI):


    def __init__(self, parent):
        WidgetUI.__init__(self, parent)
        self.setIcon(kumula.getSideBarIcon("userinterface"))
        self.cbIconSet.clear()
        myIconDir = os.path.join(os.path.dirname(sys.argv[0]), "..", "graphics")
        iconSets = os.listdir(myIconDir)
        iconSets.sort()
        for name in iconSets:
            newDir = os.path.join(myIconDir, name)
            if os.path.isdir(newDir):
                self.cbIconSet.insertItem(QString(name))


    def getDescription(self):
        myDesc = "Adjust the user interface to your needs."
        return myDesc

    def getSectionName(self):
        return "ui"

    def getValues(self):
        myValues = {
            "windim":"%i" % self.cbStoreDimensions.isChecked(),
            "tearoff":"%i" % self.cbTearOff.isChecked(),
            "textprogmenu":"%i" % self.cbTextProgMenu.isChecked(),
            "toolbuttons":self.cbToolButtons.currentItem(),
            "iconset":self.cbIconSet.currentText()
        }
        return myValues


    def setValues(self, aValueDict):
        self.cbStoreDimensions.setChecked(int(aValueDict["windim"]))
        self.cbTearOff.setChecked(int(aValueDict["tearoff"]))
        self.cbTextProgMenu.setChecked(int(aValueDict["textprogmenu"]))
        self.cbToolButtons.setCurrentItem(int(aValueDict["toolbuttons"]))
        self.cbIconSet.setCurrentText(QString(aValueDict["iconset"]))
        kumula.uiWinDim = int(aValueDict["windim"])
        kumula.uiTearOff = int(aValueDict["tearoff"])
        kumula.uiTextProgMenu = int(aValueDict["textprogmenu"])
        kumula.uiToolButtons = int(aValueDict["toolbuttons"])
        kumula.uiIconSet = QString(aValueDict["iconset"])


    def getDefaultValues(self):
        myValues = {
            "windim":"1",
            "tearoff":"0",
            "textprogmenu":"0",
            "toolbuttons":"0",
            "iconset":QString("Crystal")
        }
        return myValues

